/* ESP32_timer_alam

   Periodikus megszakítások keltése időzítővel.
   Timer0 megszakításokkal jelezzük a főprogramnak,
   hogy ideje átkapcsolni a LED-et.

   A programhoz felhasználtuk a DIY project honlap
   "ESP32. How to use Timers and Alarms with Arduino Code" című
   leírásának mintapéldáját:
   https://diyprojects.io/esp32-timers-alarms-interrupts-arduino-code/

*/
#include <Arduino.h>
boolean led_state = false;                     // LED állapotjelző
volatile int count;                            // Trigger
int totalInterrupts;                           // counts the number of triggering of the alarm

#define LED_PIN 2

hw_timer_t * timer = NULL;
//- portMUX_TYPE timerMux = portMUX_INITIALIZER_UNLOCKED;

// Megszakítást kiszolgáló eljárás
void IRAM_ATTR onTime() {
//-  portENTER_CRITICAL_ISR(&timerMux);       // Belépés a kritikus szakaszba
  count++;
//-  portEXIT_CRITICAL_ISR(&timerMux);        // Kilépés a krikikus szakaszból
}

void setup() {
  pinMode(LED_PIN, OUTPUT);                   // LED kimenet konfigurálás
  digitalWrite(LED_PIN, LOW);
  timer = timerBegin(0, 80, true);            // Timer0, 80x előosztás
  timerAttachInterrupt(timer, &onTime, true);
  timerAlarmWrite(timer, 1000000, true);      // Másodpercenként jelezzen
  timerAlarmEnable(timer);
}

void loop() {
  if (count > 0) {                            // Ha idő van...
//-    portENTER_CRITICAL(&timerMux);         // Belépés a kritikus szakaszba
    count--;                                  // Jelző törlése
//-    portEXIT_CRITICAL(&timerMux);          // Kilépés a kritikus szakaszból
    led_state = !led_state;                   // LED állapot átváltása
    digitalWrite(LED_PIN, led_state);         // LED állapot aktualizálása
  }
}
